--Callback handler - Due to Pengoros... Many thanks!
function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback)
        else
            object[event] = {object[event], callback}
        end
    end
    return callback
end

function AddEffects(Index)
	--First check that this effect is not already on the player.
	local thiseffect=effects:Get(Index)	--Get the effect
	
		local Name=thiseffect:GetName()
		
		--First check if the buff is on the ignore list. If it is return without adding.
		for i=1,#ignorelist do
			if ignorelist[i]==Name then return end
		end
		
		local found=false
		
		for i=1,#icons do
			--If it is, then update the start time and other data.
			if icons[i].Name ==Name then 
				found=true
				BuffFrame[icons[i].Frame]:RemoveItem(icons[i])
				icons[i].Frame=1
				Insert (icons[i],1)
				
				icons[i]:scaleicon		(BuffFrame[1].scale)
				icons[i].Start=				thiseffect:GetStartTime()
				icons[i].ID=					thiseffect:GetID()
				
				if icons[i].Text~=nil then icons[i].Text:SetText("") end
				
				break 
			end
		end
		--...otherwise insert the effect.
		if not(found) then icons[#icons+1]=Icon(Index) end
end

function RemoveEffects()
	--This function scans the effects and finds matches for the current effects on the player.
	--If the Buff is found it is NOT removed - otherwise it is.
	for i in pairs(icons) do
		local found=false
		for j=1,effects:GetCount() do
			local thiseffect=effects:Get(j)
			local Name=thiseffect:GetName()
			if icons[i].Name==Name then found=true break end
		end
		if not(found) then
			icons[i]:SetWantsUpdates(false)
			icons[i]:SetVisible(false)
			BuffFrame[icons[i].Frame]:RemoveItem(icons[i])
			BuffFrame[icons[i].Frame].Window:SetBackColor(Turbine.UI.Color(0,0,0,0))
			table.remove(icons,i)
		end
	end
end

--Inserts icon into frame
function Insert(icon,frame)
	icon:SetSize(32*BuffFrame[frame].scale,37*BuffFrame[frame].scale)
	BuffFrame[frame]:AddItem(icon)
end

--This function clears all current icons and then rebuilds them.
--This is used by the ignore functions, and upon first loading the plugin.
function addall()
	--First clear all
	for i=1,#icons do
		icons[1]:SetWantsUpdates(false)
		icons[1]:SetVisible(false)
		table.remove(icons,1)
	end
	for i=1,#BuffFrame do
		BuffFrame[i]:ClearItems()
		BuffFrame[i].Window:SetBackColor(Turbine.UI.Color(0,0,0,0))
	end
	
	--then load all current effects
	for i=1,effects:GetCount() do
		AddEffects(i)
	end
end